package com.l024.hi_device_util;

import android.content.Context;

import androidx.annotation.NonNull;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.l024.hi_device_util.device.DeviceModel;
import com.l024.hi_device_util.device.DeviceUtil;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

/** HiDeviceUtilPlugin */
public class HiDeviceUtilPlugin implements FlutterPlugin, MethodCallHandler {

  private MethodChannel channel;
  private Context context;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "hi_device_util");
    channel.setMethodCallHandler(this);
    context = flutterPluginBinding.getApplicationContext();
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull final Result result) {
    if(call.method.equals("getDeviceInfo")){
      DeviceUtil.getInstance().getDeviceInfo(context, new DeviceUtil.OnGaidListener() {
        @Override
        public void onSuccess(DeviceModel deviceModel) {
          System.out.println("设备信息-->"+deviceModel.toString());
          result.success(JSONObject.toJSON(deviceModel));
        }
      });
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}

